﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Data;
using C1.WPF.C1Chart;
using System.Windows;
namespace C1ChartinMVVMPart2.ViewModel
{
   public class ChartViewModel:ViewModelBase
   {
       #region Ctor..
       public ChartViewModel()
       {
           _saleslist = new ObservableCollection<Sales>();
           LoadData();
           _axisvalues = new ObservableCollection<string>();
           _axisvalues.Add("SaleValue");
           _axisvalues.Add("Volume");
           _axisvalues.Add("VolumeVsCity");
           _axisvalues.Add("ProductDiscount");
           _axisvalues.Add("VolumeTotal");
           _axisview = new CollectionView(_axisvalues);
           _axisview.CurrentChanged += new EventHandler(_axisview_CurrentChanged);
        
         
          _chartdata = new ChartData();
          ChartDataView.ItemNameBinding = new Binding("Product");
          DataSeries ds1 = new DataSeries();
          ds1.Label = "SaleValue";
          ds1.ValueBinding = new Binding("SaleValue");

          DataSeries ds2 = new DataSeries();
          ds2.Label = "Volume";
          ds2.ValueBinding = new Binding("Volume");
          ChartDataView.ItemsSource = SalesList;
       
          ChartDataView.Children.Add(ds1);
          ChartDataView.Children.Add(ds2);
         
        
           
          
       }
       #endregion
       #region private Fields
      
      
       ObservableCollection<Sales> _saleslist;
     
       ObservableCollection<string> _axisvalues;
       CollectionView _axisview;
     
       ChartData _chartdata;
       #endregion
       #region publicProperties
       public ObservableCollection<Sales> SalesList
       {
           get { return _saleslist; }
           set { _saleslist = value; }
       }
       public CollectionView AxisView
       {
           get { return _axisview; }
           set { _axisview = value; OnPropertyChanged("AxisView"); }
       }
      public ChartData ChartDataView
       {
           get { return _chartdata; }
           set { _chartdata = value; OnPropertyChanged("ChartDataView"); }
       }
      
       #endregion
       #region privateMethods
       void LoadData()
       {
           _saleslist.Add(new Sales("Confectionaries", 2500.00,300000.00,"NewYork",25.50));
           _saleslist.Add(new Sales("Plastics", 3500.00,720000.00,"Newark",15.75));
           _saleslist.Add(new Sales("Electronics", 7500.00,800000.00,"GeorgeTown",20.65));
           _saleslist.Add(new Sales("Produces", 800.00,100000.00,"Houston",30.35));
       }
       void _axisview_CurrentChanged(object sender, EventArgs e)
       {
           if (_axisview.CurrentItem.ToString() == "SaleValue")
           {
               _chartdata.Children.Clear();
             
              
               DataSeries ds1 = new DataSeries();
               ds1.Label = "SaleValue";
               ds1.ValueBinding = new Binding("SaleValue");
               ds1.ItemsSource = SalesList;

               _chartdata.Children.Add(ds1);
               _chartdata.ItemNameBinding = new Binding("Product");
               
           }
           else if (_axisview.CurrentItem.ToString() == "Volume")
           {
             
               _chartdata.Children.Clear();
               DataSeries ds2 = new DataSeries();
               ds2.ValueBinding = new Binding("Volume");
               ds2.Label = "Volume";
               ds2.ItemsSource = SalesList;
           
               _chartdata.Children.Add(ds2);
             
               _chartdata.ItemNameBinding = new Binding("Product");
           }
           else if (_axisview.CurrentItem.ToString() == "VolumeVsCity")
           {
               _chartdata.Children.Clear();
               DataSeries ds1 = new DataSeries();
               ds1.Label="Volume";
               ds1.ValueBinding = new Binding("Volume");
               ds1.ItemsSource = SalesList;
                _chartdata.Children.Add(ds1);
                 _chartdata.ItemNameBinding = new Binding("ShipCity");
                   
           }
           else if (_axisview.CurrentItem.ToString() == "ProductDiscount")
           {
               _chartdata.Children.Clear();
               DataSeries ds1 = new DataSeries();
               ds1.Label = "Discount";
               ds1.ValueBinding = new Binding("Discount");
               ds1.ItemsSource = SalesList;
               _chartdata.Children.Add(ds1);
              _chartdata.ItemNameBinding = new Binding("Product");

           }
           else if (_axisview.CurrentItem.ToString() == "VolumeTotal")
           {
               _chartdata.Children.Clear();
               DataSeries ds1 = new DataSeries();
               ds1.Label = "Volume";
               ds1.ValueBinding = new Binding("Volume");
               ds1.ItemsSource = SalesList;
                DataSeries ds2 = new DataSeries();
                ds2.Label = "Variance";
               ds2.ValueBinding = new Binding("Variance");
               ds2.ItemsSource = SalesList;
               _chartdata.Children.Add(ds1);
               _chartdata.Children.Add(ds2);
               _chartdata.ItemNameBinding = new Binding("Product");

           }
       }
       #endregion
   }
}
